;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Bubble Shark by Tradware
;;  Copyright (C) 2020
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;
;; ENTITY MANAGER
;;

;; Funciones
.globl entityman_getEntityArray_IX
.globl entityman_getEntityArray_HL
.globl entityman_getNumEntities_A 
.globl entityman_getNumBalas_A
.globl entityman_getPuntos_A
.globl entityman_sumapunto
.globl entityman_getLastElement_ptr
.globl entityman_setLastElement_ptr
.globl entityman_create_bala
.globl entityman_create
.globl entityman_create_item
.globl entityman_destroyEntity
.globl entityman_create_enemigo
.globl entityman_destroyBala
.globl gameover
.globl entityman_restartArray
.module cpct_random
.globl cpct_getRandom_mxor_u8_asm
.globl entityman_destroyObstaculo
.globl entityman_create_obstaculo
.globl entityman_getNumObstaculos_A
.globl entityman_destroyEnemigo
.globl entityman_restapunto
.globl entityman_destroyItem
.globl entityman_getNumItem_A
.globl entityman_create_balaEnemigo
.globl entityman_create_balaEnemigoIzq
.globl entityman_destroyBalaEnemigo
.globl entityman_getNumBalasEnemigo_A

;; Entity DEFINITION MACRO
.macro DefineEntityAnnonimous _flag, _x, _y, _color, _vel, _vely, _h, _w, _antx, _anty
      .db _flag
      .db _x
      .db _y
      .db _color
      .db _vel
      .db _vely
      .db _h
      .db _w
      .db _antx
      .db _anty
.endm

.macro DefineEntity _name, _flag, _x, _y, _color, _vel, _vely, _h, _w, _antx, _anty
    _name::
        DefineEntityAnnonimous
.endm

e_flag = 0
e_x = 1
e_y = 2
e_color = 3
e_vel = 4
e_vely = 5
e_h = 6
e_w = 7
e_antx = 8
e_anty = 9
sizeof_e = 10

.macro DefineEntityArray _name, _N  ;; Cuantos quiero que tenga el array
    _name::
        .rept _N
            DefineEntityAnnonimous 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAA ;; Datos que no se usan
        .endm
.endm