;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Bubble Shark by Tradware
;;  Copyright (C) 2020
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
;;
;; ENTITY MANAGER
;;

.include "cpctelera.h.s" 
.include "entity_manager.h.s"
.include "cpct_functions.h.s"

max_entities == 500
gameover:: .db 00 ;; si es 0 no hay gameover si es 1 si hay
_num_balas:: .db 0
_num_obstaculos:: .db 0 
_num_balasEnemigo:: .db 0
_num_item:: .db 0 
_num_entities:: .db 0               ;; El primer byte es el numero de entidades
_num_enemigo:: .db 0                 
_last_elem_ptr:: .dw _entity_array    ;; es el primer elemento libre
DefineEntityArray _entity_array, max_entities      ;; para que me reserve la memoria

_nave_h == 5
_nave_w == 10
y: .db 00
puntos: .db  00
;;vel: .db 01

;; NAVE -----------------------------------------------------
entityman_getLastElement_ptr::
    ld hl, (_last_elem_ptr)

    ret

entityman_setLastElement_ptr::
    ld (_last_elem_ptr), hl

    ret

entityman_getEntityArray_IX::         ;; me devuelve en ix el valor de la 1a pos de entity array
    ld ix, #_entity_array             ;; cargo en ix lo del array
    
    ret

entityman_getEntityArray_HL::         ;; me devuelve en ix el valor de la 1a pos de entity array
    ld hl, #_entity_array             ;; cargo en ix lo del array
    
    ret

entityman_getNumEntities_A::          ;; me devuelve en ix el valor de entityu array
    ld a, (_num_entities)             ;; cargo en ix lo del array
    
    ret

entityman_getNumObstaculos_A::          ;; me devuelve en ix el valor de entityu array
    ld a, (_num_obstaculos)             ;; cargo en ix lo del array
    
    ret

entityman_getNumBalas_A::          ;; me devuelve en ix el valor de entityu array
    ld a, (_num_balas)             ;; cargo en ix lo del array

    ret

entityman_getNumItem_A::          ;; me devuelve en ix el valor de entityu array
    ld a, (_num_item)             ;; cargo en ix lo del array

    ret

;;-----Para los puntos
entityman_getPuntos_A::          ;; me devuelve en ix el valor de entityu array
    ld a , (puntos)            ;; cargo en ix lo del array

    ret
entityman_sumapunto::          ;; me devuelve en ix el valor de entityu array
    ld a, (puntos)
    inc a
    ld (puntos), a
    ret

entityman_restapunto::          ;; me devuelve en ix el valor de entityu array
    ld a, (puntos)
    dec a
    ld (puntos), a
    
    ret

entityman_destroyEntity::             ;; me devuelve en ix el valor de entity array
    ld a, (_num_entities) 
    dec a
    ld (_num_entities) , a            ;; cargo en ix lo del array

    ret

entityman_destroyBala::               ;; me devuelve en ix el valor de entity array
    ld a, (_num_balas) 
    dec a
    ld (_num_balas), a                ;; cargo en ix lo del array

   call entityman_destroyEntity
 
    ret

entityman_destroyObstaculo::               ;; me devuelve en ix el valor de entity array
    ld a, (_num_obstaculos) 
    dec a
    ld (_num_obstaculos), a                ;; cargo en ix lo del array

    call entityman_destroyEntity
 
    ret

entityman_destroyItem::       
    ld a, (_num_item) 
    dec a
    ld (_num_item) , a  

    call entityman_destroyEntity        

    ret

entityman_destroyEnemigo::       
    ld a, (_num_enemigo) 
    dec a
    ld (_num_enemigo) , a  

    call entityman_destroyEntity        

    ret

entityman_destroyBalaEnemigo::    
    ld a, (_num_balasEnemigo) 
    dec a
    ld (_num_balasEnemigo), a      

    call entityman_destroyEntity
 
    ret

entityman_getNumBalasEnemigo_A::
    ld a, (_num_balasEnemigo)  

    ret

entityman_create::
    ld de, (_last_elem_ptr)           ;; la posicion libre de posiciones se guarda en el acumulador hl
    ld bc, #sizeof_e
    ldir                              ;; se meten los valores de hl en los bytes que van de de a de+bc                   
    ld hl, (_last_elem_ptr)
    ld bc, #sizeof_e
    add hl, bc
    ld (_last_elem_ptr), hl           ;; la posicion libre ahora vale hl
    ld a, (_num_entities)       
    inc a                      
    ld (_num_entities), a             

   ret

entityman_create_enemigo::
    call entityman_create         
        
        ld a, (_num_enemigo)           
        inc a                             
        ld (_num_enemigo), a              

   ret

entityman_create_balaEnemigo::
    ld de, (_last_elem_ptr)    
    ld bc, #sizeof_e
    ldir              
    ld hl, (_last_elem_ptr)
    ld a, e_x(ix)
    ld c, a
    ld a, #8
    add a, c
    inc hl
    ld (hl), a          
    inc hl
    ld a, e_y(ix)
    ld b, a
    ld a, #5
    add a, b
    ld (hl), a
    ld bc, #0x0008
    add hl, bc
    ld (_last_elem_ptr), hl
    
    ld a, (_num_entities)      
    inc a                    
    ld (_num_entities), a      
    ld a, (_num_balasEnemigo)    
    inc a                      
    ld (_num_balasEnemigo), a 

    ret

entityman_create_balaEnemigoIzq::
    ld de, (_last_elem_ptr)    
    ld bc, #sizeof_e
    ldir              
    ld hl, (_last_elem_ptr)
    ld a, e_x(ix)
    inc hl
    ld (hl), a          
    inc hl
    ld a, e_y(ix)
    ld b, a
    ld a, #5
    add a, b
    ld (hl), a
    ld bc, #0x0008
    add hl, bc
    ld (_last_elem_ptr), hl
    
    ld a, (_num_entities)      
    inc a                    
    ld (_num_entities), a      
    ld a, (_num_balasEnemigo)    
    inc a                      
    ld (_num_balasEnemigo), a 

    ret

entityman_create_item::
    call entityman_create       
    ld a, (_num_item)             
    inc a                             
    ld (_num_item), a   

   ret

entityman_create_obstaculo::
    call entityman_create            
    ld a, (_num_obstaculos)           
    inc a                             
    ld (_num_obstaculos), a 
ret

entityman_create_bala::
    call entityman_getEntityArray_IX  ;; esto no da la nave
    ld de, (_last_elem_ptr)           ;; la posicion libre de posiciones se guarda en el acumulador hl
    ld bc, #sizeof_e
    ldir   
                        
    ld hl, (_last_elem_ptr)

    ld a, e_x(ix)
    ld c, a
    ld a, #12
    add a, c
    inc hl
    ld (hl), a                        ;; carga en la memoria de video
    inc hl
    ld a, e_y(ix)
    ld b, a
    ld a, #8
    add a, b
    ld (hl), a
    ld bc, #0x0008
    add hl, bc
    ld (_last_elem_ptr), hl
    
    ld a, (_num_entities)       
    inc a                    
    ld (_num_entities), a   
    ld a, (_num_balas)       
    inc a            
    ld (_num_balas), a          

   ret

;; destruir las entidades 
entityman_restartArray::
    ld hl, #_entity_array
    ld (_last_elem_ptr), hl
    ld a, #0
    ld (y), a
    ld (_num_entities), a
    ld (_num_balas), a
    ld (_num_item), a
    ld (_num_obstaculos), a
    ld (puntos),a
    ld (_num_balasEnemigo), a

ret