;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Bubble Shark by Tradware
;;  Copyright (C) 2020
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
;;
;; INPUT SYSTEM
;;

.include "cpctelera.h.s" 
.include "input_system.h.s"
.include "entity_manager.h.s"
.include "cpct_functions.h.s"

naveBala: .db 03, 00, 00, #0x0C, 02, 00, #8, #4, 00, 00

.globl _sfx_disparo

sys_input_update::
    ld e_vel(ix), #0
    ld e_vely(ix), #0

    call cpct_scanKeyboard_f_asm

    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    jr nz, A_Pressed
    ld hl, #Joy0_Left
    call cpct_isKeyPressed_asm
    jr z, A_NotPressed

    A_Pressed:
        ld e_vel(ix), #-2
    A_NotPressed:

        ld hl, #Key_P
        call cpct_isKeyPressed_asm
        jr nz, D_Pressed
        ld hl, #Joy0_Right
        call cpct_isKeyPressed_asm
        jr z, D_NotPressed

    D_Pressed:
        ld e_vel(ix), #2
    D_NotPressed:

    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr nz, S_Pressed
    ld hl, #Joy0_Down
    call cpct_isKeyPressed_asm
    jr z, S_NotPressed

    S_Pressed:
        ld e_vely(ix), #4
    S_NotPressed:
        ld hl, #Key_Q
        call cpct_isKeyPressed_asm
        jr nz, W_Pressed
        ld hl, #Joy0_Up
        call cpct_isKeyPressed_asm
        jr z, W_NotPressed
    W_Pressed:
        ld e_vely(ix), #-4
    W_NotPressed:

    ;; BALA
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr nz, N_Pressed
    ld hl, #Joy0_Fire1
    call cpct_isKeyPressed_asm
    jr z, N_NotPressed

    N_Pressed:
        ld c , #01
        call entityman_getNumBalas_A
        cp c
        jr nc, N_NotPressed

        ;;ld de, #_sfx_disparo
        ;;call cpct_akp_musicInit_asm
        ;;call cpct_akp_musicPlay_asm
        ld hl, #naveBala
        call entityman_create_bala
    N_NotPressed:

    ;; SALIR
    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr z, Esc_NotPressed

    Esc_Pressed:
        ld a, #01
        ld (gameover),a
    Esc_NotPressed:
    
ret
