;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Bubble Shark by Tradware
;;  Copyright (C) 2020
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"       ;; incluye el archivo, copia y pega el archivo, el archivo lo coge del -I que hace que busque los ficheros si no estan en local
.include "render_system.h.s"   ;; es lo mismo que poner .globl de los rendersysinit y update
.include "entity_manager.h.s"  
.include "cpct_functions.h.s" 
.include "physics_system.h.s"  
.include "input_system.h.s"   
.module cpct_random
.globl cpct_getRandom_mxor_u16_asm

.area _DATA

.area _CODE
;;    FLAGS
;; 00 invalido
;; 01 tiburon
;; 02 mina
;; 03 burbuja
;; 04 pez
;; 05 enemigo
;; 06 balaEnemigo
;; 07 balaEnemigoIzq
;; 08 submarino

naveEspacial: .db #01, #00, #50, #0xFF, #1, #1, #16, #12, #0, #0
obstaculo1:   .db #02, #70, #44, #0x0C, #01, #01, #20, #10, #00, #00
obstaculo2:   .db #02, #70, #66, #0x0C, #01, #01, #20, #10, #00, #00
obstaculo3:   .db #02, #70, #88, #0x0C, #01, #01, #20, #10, #00, #00
obstaculo4:   .db #02, #70, #110, #0x0C, #01, #01, #20, #10, #00, #00
obstaculo5:   .db #02, #70, #132, #0x0C, #01, #01, #20, #10, #00, #00
submarino1:   .db #08, #70, #44, #0x0C, #01, #01, #20, #10, #00, #00
submarino2:   .db #08, #70, #66, #0x0C, #01, #01, #20, #10, #00, #00
submarino3:   .db #08, #70, #88, #0x0C, #01, #01, #20, #10, #00, #00
submarino4:   .db #08, #70, #110, #0x0C, #01, #01, #20, #10, #00, #00
submarino5:   .db #08, #70, #132, #0x0C, #01, #01, #20, #10, #00, #00
item1:        .db #04, #74, #48, #0xFF, #01, #01, #8, #4, #00, #00
item2:        .db #04, #74, #70, #0xFF, #01, #01, #8, #4, #00, #00
item3:        .db #04, #74, #92, #0xFF, #01, #01, #8, #4, #00, #00
item4:        .db #04, #74, #114, #0xFF, #01, #01, #8, #4, #00, #00
item5:        .db #04, #74, #136, #0xFF, #01, #01, #8, #4, #00, #00
enemigo1:     .db #05, #70, #44, #0x0F, #01, #01, #20, #10, #00, #00
enemigo2:     .db #05, #70, #66, #0x0F, #01, #01, #20, #10, #00, #00
enemigo3:     .db #05, #70, #88, #0x0F, #01, #01, #20, #10, #00, #00
enemigo4:     .db #05, #70, #110, #0x0F, #01, #01, #20, #10, #00, #00
enemigo5:     .db #05, #70, #132, #0x0F, #01, #01, #20, #10, #00, #00

.macro setNextManIR direccion
  ld hl, #direccion
  ld (0x39), hl
.endm

.macro setNumIR number
  ld a, #number  
  ld (num_i), a
.endm

num_i:: .db 6

x: .db #20
y: .db #12
level: .db #01
n_rends: .db #00
wait4rend: .db 0

man_ir1::
    cpctm_push  af, bc, de, hl

    setNumIR 1
    setNextManIR man_ir2

    ;;cpctm_setBorder_asm HW_BLACK
    call cpct_akp_musicPlay_asm

    cpctm_pop   hl, de, bc, af
    ei
    reti

man_ir2::
    cpctm_push  af, bc, hl

    setNumIR 2
    setNextManIR man_ir3

    ;;cpctm_setBorder_asm HW_GREEN

    cpctm_pop   hl, bc, af
    ei
    reti

man_ir3::
    cpctm_push  af, bc, hl

    setNumIR 3
    setNextManIR man_ir4

    ;;cpctm_setBorder_asm HW_RED

    cpctm_pop   hl, bc, af
    ei
    reti

man_ir4::
    cpctm_push  af, bc, hl

    setNumIR 4
    setNextManIR man_ir5

    ;;cpctm_setBorder_asm HW_BLACK

    cpctm_pop   hl, bc, af
    ei
    reti

man_ir5::
    cpctm_push  af, bc, hl

    setNumIR 5
    setNextManIR man_ir6

    ;;cpctm_setBorder_asm HW_GREEN

    cpctm_pop   hl, bc, af
    ei
    reti

man_ir6::
    cpctm_push  af, bc, hl

    setNumIR 6
    setNextManIR man_ir1

    ld a, #1
    ld (wait4rend), a

    ;;cpctm_setBorder_asm HW_RED

    cpctm_pop   hl, bc, af
    ei
    reti

set_man_ir::
  im  1
  call cpct_waitVSYNC_asm
  halt
  halt
  call cpct_waitVSYNC_asm
  di

  ld a, #0xC3
  ld (0x38), a

  ld hl, #man_ir1
  ld (0x39), hl
  ei
  ret

.globl _song_menu
.globl _song_menu2
.globl _song_muerte
.globl _song_level

_main::
  call cpct_disableFirmware_asm
  call rendersys_init
  call set_man_ir
  
  ;; Esto estaría mejor en una funcion music init
  ld de, #_song_menu2
  call cpct_akp_musicInit_asm

  loop_menu:
    call cpct_waitVSYNC_asm
    
    call menu_init
    ld a, (animate)
    inc a
    ld (animate), a

    ld a, #10
    halt
    dec a
    jr nz, .-2

    call cpct_scanKeyboard_f_asm

    ld hl, #Key_1
    call cpct_isKeyPressed_asm
    jr z, uno_NotPressed

    uno_Pressed:
        call level0
    uno_NotPressed:
        ld hl, #Key_2
        call cpct_isKeyPressed_asm
        jr z, dos_NotPressed
    
    dos_Pressed:
      call borrar_menu
      call creditos

    dos_NotPressed:
  jr z, loop_menu

level0:
  call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level0_init
  jp start

level1:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level1_init
  jp start

level02:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level02_init
  jp start

level2:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level2_init
  jp start

level3:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level3_init
  jp start

level03:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level03_init
  jp start

level04:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level04_init
  jp start

level4:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level4_init
  jp start

level5:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level5_init
  jp start

level6:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level6_init
  jp start

level06:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level06_init
  jp start

level7:
call cpct_akp_stop_asm
  ld de, #_song_menu
  call cpct_akp_musicInit_asm
  call fondo_juego_borrar
  call creditos_borrar
  call borrar_menu
  call level7_init
  jp start
start: 
  ld a, #78
  halt  
  halt     
  halt 
  halt
  halt
  dec a
  jr nz, .-6

  call borrar_level

  ld a, #00
  ld (gameover), a
  call creditos_borrar
  call borrar_menu

  ;; -------------------
  ;; Aqui creamos el HUD
  call hud_init
  ;; -------------------
  call fondo_juego
  
  call entityman_restartArray

  ld hl, #naveEspacial
  call entityman_create

  ld a, (level)
  ld c, #01
  sub c
  jp z, level0_loop

  ld a, (level)
  ld c, #02
  sub c
  jp z, level1_loop

  ld a, (level)
  ld c, #03
  sub c
  jp z, level02_loop

  ld a, (level)
  ld c, #04
  sub c
  jp z, level03_loop

  ld a, (level)
  ld c, #05
  sub c
  jp z, level04_loop

  ld a, (level)
  ld c, #06
  sub c
  jp z, level2_loop

  ld a, (level)
  ld c, #07
  sub c
  jp z, level3_loop

  ld a, (level)
  ld c, #08
  sub c
  jp z, level6_loop

  ld a, (level)
  ld c, #09
  sub c
  jp z, level4_loop

  ld a, (level)
  ld c, #10
  sub c
  jp z, level5_loop

  ld a, (level)
  ld c, #11
  sub c
  jp z, level06_loop

  ld a, (level)
  ld c, #12
  sub c
  jp z, level7_loop


level0_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #03
  sub c
  jp z, win_level0

  ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, l016
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

l016:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, l032
  ld hl, #item3
  call entityman_create_item

l032:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, l048
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

l048:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, l072
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo

l072:
  ld a,(n_rends)
  ld c, #72
  sub c
  jr nz, l0104
  ld hl, #obstaculo3
  call entityman_create_obstaculo

l0104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, l0144
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #item5
  call entityman_create_item

l0144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, l0168
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

l0168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, l0184
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  
l0184:
  ld a,(n_rends)
  ld c, #184
  sub c
  jr nz, l0200
  ld hl, #item4
  call entityman_create_item

l0200:
  ld a,(n_rends)
  ld c, #200
  sub c
  jr nz, acaba0
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

acaba0:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

  ld a, (n_rends)  
  inc a
  ld (n_rends), a
  jp level0_loop

level1_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #06
  sub c
  jp z, win_level1

  ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, o16
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

o16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, o32
  ld hl, #item3
  call entityman_create_item
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

o32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, o48
  ld hl, #obstaculo3
  call entityman_create_obstaculo

o48:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, o64
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

o64:
  ld a,(n_rends)
  ld c, #64
  sub c
  jr nz, o72
  ld hl, #obstaculo3
  call entityman_create_obstaculo

o72:
  ld a,(n_rends)
  ld c, #72
  sub c
  jr nz, o80
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

o80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, o96
  ld hl, #item3
  call entityman_create_item
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

o96:
  ld a,(n_rends)
  ld c, #96
  sub c
  jr nz, o104
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  
o104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, o120
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

o120:
  ld a,(n_rends)
  ld c, #120
  sub c
  jr nz, o128
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  
o128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, o144
   ld hl, #item1
  call entityman_create_item

o144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, o152
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

o152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, o168
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

o168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, o176
  ld hl, #obstaculo4
  call entityman_create_obstaculo

o176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, o184
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

o184:
  ld a,(n_rends)
  ld c, #184
  sub c
  jr nz, o192
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #item4
  call entityman_create_item

o192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, o200
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

o200:
  ld a,(n_rends)
  ld c, #200
  sub c
  jr nz, o216
  ld hl, #obstaculo4
  call entityman_create_obstaculo

o216:
  ld a,(n_rends)
  ld c, #216
  sub c
  jr nz, o232
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo1
  call entityman_create_obstaculo

o232:
  ld a,(n_rends)
  ld c, #232
  sub c
  jr nz, o248
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
   ld hl, #item2
  call entityman_create_item

 o248:
  ld a,(n_rends)
  ld c, #248
  sub c
  jr nz, acaba
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

acaba:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

  ld a, (n_rends)  
  inc a
  ld (n_rends), a
  jp level1_loop

level02_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #06
  sub c
  jp z, win_level02

  ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, sec16
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

sec16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, sec32
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

sec32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, sec40
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sec40:
  ld a,(n_rends)
  ld c, #40
  sub c
  jr nz, sec56
  ld hl, #item4
  call entityman_create_item

sec56:
  ld a,(n_rends)
  ld c, #56
  sub c
  jr nz, sec72
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sec72:
  ld a,(n_rends)
  ld c, #72
  sub c
  jr nz, sec80
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item

sec80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, sec96
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sec96:
  ld a,(n_rends)
  ld c, #96
  sub c
  jr nz, sec112
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  
sec112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, sec128
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #item4
  call entityman_create_item
  ld hl, #obstaculo5
  call entityman_create_obstaculo

sec128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, sec136
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  

sec136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, sec144
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sec144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, sec152
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #item5
  call entityman_create_item

sec152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, sec160
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sec160:
  ld a,(n_rends)
  ld c, #160
  sub c
  jr nz, sec176
  ld hl, #item2
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

sec176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, sec192
  ld hl, #item2
  call entityman_create_item
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

sec192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, sec208
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

sec208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, acabaSec
  ld hl, #obstaculo3
  call entityman_create_obstaculo

acabaSec:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

  ld a, (n_rends)  
  inc a
  ld (n_rends), a
  jp level02_loop

level2_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A

  ld c, #9
  sub c
  jp z, win_level2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover


  ;; ******** Creamos las nuevas entidades *******   
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, seg16
  ld hl, #submarino3
  call entityman_create_obstaculo

seg16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, seg40
  ld hl, #item3
  call entityman_create_item
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

seg40:
  ld a,(n_rends)
  ld c, #40
  sub c
  jr nz, seg56
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

seg56:
  ld a,(n_rends)
  ld c, #56
  sub c
  jr nz, seg64
  ld hl, #item2
  call entityman_create_item

seg64:
  ld a,(n_rends)
  ld c, #64
  sub c
  jr nz, seg80
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

seg80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, seg88
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  
seg88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, seg104
  ld hl, #item5
  call entityman_create_item

seg104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, seg112
  ld hl, #item1
  call entityman_create_item

seg112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, seg120
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

seg120:
  ld a,(n_rends)
  ld c, #120
  sub c
  jr nz, seg136
  ld hl, #item5
  call entityman_create_item

seg136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, seg152
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo

seg152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, seg168
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item

seg168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, seg176
  ld hl, #submarino3
  call entityman_create_obstaculo
  
seg176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, seg200
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo
  ld hl, #item1
  call entityman_create_item

seg200:
  ld a,(n_rends)
  ld c, #200
  sub c
  jr nz, seg208
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
 
seg208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, seg216
  ld hl, #item5
  call entityman_create_item

seg216:
  ld a,(n_rends)
  ld c, #216
  sub c
  jr nz, seg224
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

seg224:
  ld a,(n_rends)
  ld c, #224
  sub c
  jr nz, seg232
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  
seg232:
  ld a,(n_rends)
  ld c, #232
  sub c
  jr nz, seg248
  ld hl, #submarino3
  call entityman_create_obstaculo
 
seg248:
  ld a,(n_rends)
  ld c, #248
  sub c
  jr nz, acaba2
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  ld hl, #obstaculo1
  call entityman_create_obstaculo

acaba2:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level2_loop

level03_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #08
  sub c
  jp z, win_level03

  ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, tec24
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

tec24:
  ld a,(n_rends)
  ld c, #24
  sub c
  jr nz, tec48
  ld hl, #item1
  call entityman_create_item
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

tec48:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, tec64
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #item5
  call entityman_create_item

tec64:
  ld a,(n_rends)
  ld c, #64
  sub c
  jr nz, tec88
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo

tec88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, tec112
  ld hl, #item1
  call entityman_create_item
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

tec112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, tec120
  ld hl, #obstaculo3
  call entityman_create_obstaculo

tec120:
  ld a,(n_rends)
  ld c, #120
  sub c
  jr nz, tec128
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

tec128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, tec144
  ld hl, #item4
  call entityman_create_item
  
tec144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, tec152
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo

tec152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, tec160
  ld hl, #obstaculo3
  call entityman_create_obstaculo

tec160:
  ld a,(n_rends)
  ld c, #160
  sub c
  jr nz, tec168
  ld hl, #item1
  call entityman_create_item
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

tec168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, tec176
  ld hl, #obstaculo3
  call entityman_create_obstaculo

tec176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, tec192
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo

tec192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, tec208
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #item5
  call entityman_create_item

tec208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, tec216
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

tec216:
  ld a,(n_rends)
  ld c, #216
  sub c
  jr nz, tec224
  ld hl, #submarino2
  call entityman_create_obstaculo

tec224:
  ld a,(n_rends)
  ld c, #224
  sub c
  jr nz, tec232
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item

tec232:
  ld a,(n_rends)
  ld c, #232
  sub c
  jr nz, tec240
  ld hl, #submarino4
  call entityman_create_obstaculo

tec240:
  ld a,(n_rends)
  ld c, #240
  sub c
  jr nz, acabaTec
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

acabaTec:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

  ld a, (n_rends)  
  inc a
  ld (n_rends), a
  jp level03_loop

level3_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #8
  sub c
  jp z, win_level3

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover


  ;; ******** Creamos las nuevas entidades *******   
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, ter16
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

ter16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, ter32
  ld hl, #item2
  call entityman_create_item
  
ter32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, ter56
  ld hl, #enemigo2
  call entityman_create_enemigo

ter56:
  ld a,(n_rends)
  ld c, #56
  sub c
  jr nz, ter64
  ld hl, #obstaculo3
  call entityman_create_obstaculo

ter64:
  ld a,(n_rends)
  ld c, #64
  sub c
  jr nz, ter72
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

ter72:
  ld a,(n_rends)
  ld c, #72
  sub c
  jr nz, ter88
  ld hl, #item3
  call entityman_create_item

ter88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, ter104
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

ter104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, ter112
  ld hl, #item1
  call entityman_create_item

ter112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, ter120
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  
ter120:
  ld a,(n_rends)
  ld c, #120
  sub c
  jr nz, ter128
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo

ter128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, ter136
  ld hl, #item5
  call entityman_create_item
  
ter136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, ter144
  ld hl, #enemigo1
  call entityman_create_enemigo
 
ter144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, ter152
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

ter152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, ter160
  ld hl, #obstaculo3
  call entityman_create_obstaculo

ter160:
  ld a,(n_rends)
  ld c, #160
  sub c
  jr nz, ter168
  ld hl, #obstaculo2
  call entityman_create_obstaculo  
  ld hl, #item4
  call entityman_create_item 

ter168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, ter176
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  
ter176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, ter192
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

ter192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, ter200
  ld hl, #item5
  call entityman_create_item
 
ter200:
  ld a,(n_rends)
  ld c, #200
  sub c
  jr nz, ter224
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo
 
ter224:
  ld a,(n_rends)
  ld c, #224
  sub c
  jr nz, ter232
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item

ter232:
  ld a,(n_rends)
  ld c, #232
  sub c
  jr nz, acaba3
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo

acaba3:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level3_loop

level04_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #7
  sub c
  jp z, win_level04

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover


  ;; ******** Creamos las nuevas entidades *******   
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, cat24
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

cat24:
  ld a,(n_rends)
  ld c, #24
  sub c
  jr nz, cat32
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  
cat32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, cat40
  ld hl, #item5
  call entityman_create_item

cat40:
  ld a,(n_rends)
  ld c, #40
  sub c
  jr nz, cat48
  ld hl, #obstaculo3
  call entityman_create_obstaculo

cat48:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, cat56
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo

cat56:
  ld a,(n_rends)
  ld c, #56
  sub c
  jr nz, cat80
  ld hl, #enemigo5
  call entityman_create_enemigo

cat80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, cat88
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo

cat88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, cat104
  ld hl, #obstaculo2
  call entityman_create_obstaculo

cat104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, cat112
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  
cat112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, cat120
  ld hl, #item1
  call entityman_create_item
  ld hl, #obstaculo4
  call entityman_create_obstaculo

cat120:
  ld a,(n_rends)
  ld c, #120
  sub c
  jr nz, cat128
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  
cat128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, cat136
  ld hl, #obstaculo3
  call entityman_create_obstaculo
 
cat136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, cat144
  ld hl, #obstaculo2
  call entityman_create_obstaculo

cat144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, cat160
  ld hl, #enemigo1
  call entityman_create_enemigo
  ld hl, #item4
  call entityman_create_item

cat160:
  ld a,(n_rends)
  ld c, #160
  sub c
  jr nz, cat168
  ld hl, #obstaculo2
  call entityman_create_obstaculo  
  ld hl, #obstaculo3
  call entityman_create_obstaculo  

cat168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, cat176
  ld hl, #obstaculo1
  call entityman_create_obstaculo  
  ld hl, #obstaculo5
  call entityman_create_obstaculo 

cat176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, cat192
  ld hl, #obstaculo2
  call entityman_create_obstaculo  
  ld hl, #obstaculo3
  call entityman_create_obstaculo 
 
cat192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, cat200
  ld hl, #obstaculo4
  call entityman_create_obstaculo  
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo  
  ld hl, #obstaculo3
  call entityman_create_obstaculo 
  ld hl, #obstaculo5
  call entityman_create_obstaculo  
 
cat200:
  ld a,(n_rends)
  ld c, #200
  sub c
  jr nz, cat208
  ld hl, #item5
  call entityman_create_item

cat208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, cat224
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

cat224:
  ld a,(n_rends)
  ld c, #224
  sub c
  jr nz, cat232
  ld hl, #obstaculo4
  call entityman_create_obstaculo

cat232:
  ld a,(n_rends)
  ld c, #232
  sub c
  jr nz, acaba04
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #enemigo5
  call entityman_create_enemigo
 
acaba04:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level04_loop

level4_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #7
  sub c
  jp z, win_level4

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover


  ;; ******** Creamos las nuevas entidades *******   
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, cua8
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

cua8:
  ld a,(n_rends)
  ld c, #8
  sub c
  jr nz, cua16
  ld hl, #obstaculo3
  call entityman_create_obstaculo

cua16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, cua24
  ld hl, #item5
  call entityman_create_item

cua24:
  ld a,(n_rends)
  ld c, #24
  sub c
  jr nz, cua32
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  
cua32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, cua40
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo

cua40:
  ld a,(n_rends)
  ld c, #40
  sub c
  jr nz, cua56
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

cua56:
  ld a,(n_rends)
  ld c, #56
  sub c
  jr nz, cua64
  ld hl, #item1
  call entityman_create_item
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo

cua64:
  ld a,(n_rends)
  ld c, #64
  sub c
  jr nz, cua72
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

cua72:
  ld a,(n_rends)
  ld c, #72
  sub c
  jr nz, cua80
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  
cua80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, cua88
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

cua88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, cua104
  ld hl, #item5
  call entityman_create_item


cua104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, cua128
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

  
cua128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, cua136
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo

cua136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, cua152
  ld hl, #item4
  call entityman_create_item

cua152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, cua160
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo

cua160:
  ld a,(n_rends)
  ld c, #160
  sub c
  jr nz, cua168 
  ld hl, #item3
  call entityman_create_item 

cua168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, cua176
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  

cua176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, cua192
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

cua192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, cua200
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo
 

cua200:
  ld a,(n_rends)
  ld c, #200
  sub c
  jr nz, cua208
  ld hl, #submarino3
  call entityman_create_obstaculo
 

cua208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, cua216
  ld hl, #item5
  call entityman_create_item

cua216:
  ld a,(n_rends)
  ld c, #216
  sub c
  jr nz, cua224
  ld hl, #obstaculo5
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo1
  call entityman_create_obstaculo

cua224:
  ld a,(n_rends)
  ld c, #224
  sub c
  jr nz, cua240
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5


cua240:
  ld a,(n_rends)
  ld c, #240
  sub c
  jr nz, acaba4
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item

acaba4:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level4_loop

level5_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #10
  sub c
  jp z, win_level5

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

   ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, qui8
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

qui8:
  ld a,(n_rends)
  ld c, #8
  sub c
  jr nz, qui16
  ld hl, #submarino2
  call entityman_create_obstaculo

qui16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, qui32
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

qui32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, qui40
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item
  ld hl, #submarino5
  call entityman_create_obstaculo


qui40:
  ld a,(n_rends)
  ld c, #40
  sub c
  jr nz, qui48
  ld hl, #submarino4
  call entityman_create_obstaculo

qui48:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, qui64
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

qui64:
  ld a,(n_rends)
  ld c, #64
  sub c
  jr nz, qui72
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

  

qui72:
  ld a,(n_rends)
  ld c, #72
  sub c
  jr nz, qui80
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  
qui80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, qui88
  ld hl, #obstaculo3
  call entityman_create_obstaculo

qui88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, qui96
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  

qui96:
  ld a,(n_rends)
  ld c, #96
  sub c
  jr nz, qui104
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item
  ld hl, #submarino5
  call entityman_create_obstaculo

qui104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, qui112
  ld hl, #submarino3
  call entityman_create_obstaculo

qui112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, qui120
  ld hl, #obstaculo4
  call entityman_create_obstaculo

qui120:
  ld a,(n_rends)
  ld c, #120
  sub c
  jr nz, qui128
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

qui128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, qui136
  ld hl, #obstaculo4
  call entityman_create_obstaculo

qui136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, qui144
  ld hl, #item1
  call entityman_create_item
  ld hl, #item2
  call entityman_create_item
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

qui144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, qui152
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #item5
  call entityman_create_item

qui152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, qui176
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

qui176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, qui184
  ld hl, #obstaculo3
  call entityman_create_obstaculo

qui184:
  ld a,(n_rends)
  ld c, #184
  sub c
  jr nz, qui192
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item
   ld hl, #submarino4
  call entityman_create_obstaculo

qui192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, qui208
  ld hl, #obstaculo3
  call entityman_create_obstaculo

qui208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, qui224
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #item2
  call entityman_create_item
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #item4
  call entityman_create_item
  ld hl, #submarino5
  call entityman_create_obstaculo

 qui224:
  ld a,(n_rends)
  ld c, #248
  sub c
  jr nz, acaba5
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item
  ld hl, #submarino4
  call entityman_create_obstaculo

acaba5:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level5_loop

level6_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #7
  sub c
  jp z, win_level6

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

   ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, se8
  ld hl, #enemigo4
  call entityman_create_enemigo

se8:
  ld a,(n_rends)
  ld c, #8
  sub c
  jr nz, se32
  ld hl, #item1
  call entityman_create_item

se32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, se40
  ld hl, #item5
  call entityman_create_item

se40:
  ld a,(n_rends)
  ld c, #40
  sub c
  jr nz, se48
  ld hl, #enemigo2
  call entityman_create_enemigo


se48:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, se80
  ld hl, #enemigo3
  call entityman_create_enemigo

se80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, se88
  ld hl, #enemigo5
  call entityman_create_enemigo

se88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, se112
  ld hl, #item2
  call entityman_create_item

se112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, se136
  ld hl, #enemigo1
  call entityman_create_enemigo
  ld hl, #enemigo5
  call entityman_create_enemigo
  
se136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, se152
  ld hl, #enemigo4
  call entityman_create_enemigo

se152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, se168
  ld hl, #item5
  call entityman_create_item
  
se168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, se184
  ld hl, #enemigo3
  call entityman_create_enemigo

se184:
  ld a,(n_rends)
  ld c, #184
  sub c
  jr nz, se192
  ld hl, #item1
  call entityman_create_item

se192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, se200
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

se200:
  ld a,(n_rends)
  ld c, #200
  sub c
  jr nz, se208
  ld hl, #item5
  call entityman_create_item

se208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, se216
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

se216:
  ld a,(n_rends)
  ld c, #216
  sub c
  jr nz, se224
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo

se224:
  ld a,(n_rends)
  ld c, #224
  sub c
  jr nz, se240
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #item5
  call entityman_create_item

se240:
  ld a,(n_rends)
  ld c, #240
  sub c
  jr nz, acaba6
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

acaba6:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level6_loop

level06_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #5
  sub c
  jp z, win_level06

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

   ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, six16
  ld hl, #submarino1
  call entityman_create_enemigo
  ld hl, #submarino2
  call entityman_create_enemigo
  ld hl, #submarino3
  call entityman_create_enemigo
  ld hl, #obstaculo4
  call entityman_create_enemigo
  ld hl, #obstaculo5
  call entityman_create_enemigo

six16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, six24
  ld hl, #obstaculo2
  call entityman_create_enemigo
  ld hl, #enemigo5
  call entityman_create_enemigo

six24:
  ld a,(n_rends)
  ld c, #24
  sub c
  jr nz, six32
  ld hl, #obstaculo3
  call entityman_create_enemigo
  ld hl, #item4
  call entityman_create_item

six32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, six48
  ld hl, #obstaculo2
  call entityman_create_enemigo


six48:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, six56
  ld hl, #enemigo1
  call entityman_create_enemigo
  ld hl, #enemigo4
  call entityman_create_enemigo

six56:
  ld a,(n_rends)
  ld c, #56
  sub c
  jr nz, six80
  ld hl, #submarino1
  call entityman_create_enemigo
  ld hl, #submarino4
  call entityman_create_enemigo
  ld hl, #obstaculo2
  call entityman_create_enemigo
  ld hl, #obstaculo3
  call entityman_create_enemigo

six80:
  ld a,(n_rends)
  ld c, #80
  sub c
  jr nz, six88
  ld hl, #submarino2
  call entityman_create_enemigo
  ld hl, #submarino3
  call entityman_create_enemigo
  ld hl, #obstaculo4
  call entityman_create_enemigo
  ld hl, #submarino5
  call entityman_create_enemigo

six88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, six104
  ld hl, #item5
  call entityman_create_item
  
six104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, six128
  ld hl, #enemigo2
  call entityman_create_enemigo
  ld hl, #enemigo5
  call entityman_create_enemigo

six128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, six144
  ld hl, #submarino2
  call entityman_create_enemigo
  ld hl, #obstaculo3
  call entityman_create_enemigo
  ld hl, #obstaculo4
  call entityman_create_enemigo
  ld hl, #obstaculo5
  call entityman_create_enemigo
  
six144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, six160
  ld hl, #enemigo1
  call entityman_create_enemigo
  ld hl, #submarino2
  call entityman_create_enemigo
  ld hl, #item3
  call entityman_create_item

six160:
  ld a,(n_rends)
  ld c, #160
  sub c
  jr nz, six176
  ld hl, #submarino2
  call entityman_create_enemigo
  ld hl, #submarino3
  call entityman_create_enemigo
  ld hl, #submarino4
  call entityman_create_enemigo

six176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, six184
  ld hl, #enemigo5
  call entityman_create_enemigo

six184:
  ld a,(n_rends)
  ld c, #184
  sub c
  jr nz, six192
  ld hl, #obstaculo1
  call entityman_create_enemigo
  ld hl, #obstaculo2
  call entityman_create_enemigo
  ld hl, #enemigo4
  call entityman_create_enemigo

six192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, six216
  ld hl, #submarino3
  call entityman_create_enemigo
  ld hl, #submarino5
  call entityman_create_enemigo

six216:
  ld a,(n_rends)
  ld c, #216
  sub c
  jr nz, six224
  ld hl, #submarino2
  call entityman_create_enemigo
  ld hl, #obstaculo1
  call entityman_create_enemigo
  ld hl, #submarino4
  call entityman_create_enemigo
  ld hl, #obstaculo5
  call entityman_create_enemigo

six224:
  ld a,(n_rends)
  ld c, #224
  sub c
  jr nz, six232
  ld hl, #item1
  call entityman_create_item

six232:
  ld a,(n_rends)
  ld c, #232
  sub c
  jr nz, acaba06
  ld hl, #enemigo3
  call entityman_create_enemigo
  ld hl, #enemigo5
  call entityman_create_enemigo

acaba06:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level06_loop

level7_loop:
  call loop

  ;; Comprobamos si tenemos los puntos necesarios para pasar el nivel
  call entityman_getPuntos_A
  ld c, #7
  sub c
  jp z, win_level7

  ;; Comprobamos si ha habido gameover
  ld a, (gameover)
  ld c, #01
  sub c
  jp z, loop_gameover

   ;; ******** Creamos las nuevas entidades *******    
  ;; CREAMOS OBSTACULOS
  ld a,(n_rends)
  ld c, #00
  sub c
  jr nz, sie8
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo

sie8:
  ld a,(n_rends)
  ld c, #8
  sub c
  jr nz, sie16
  ld hl, #item2
  call entityman_create_item

sie16:
  ld a,(n_rends)
  ld c, #16
  sub c
  jr nz, sie32
  ld hl, #submarino2
  call entityman_create_obstaculo

sie32:
  ld a,(n_rends)
  ld c, #32
  sub c
  jr nz, sie40
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sie40:
  ld a,(n_rends)
  ld c, #40
  sub c
  jr nz, sie48
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

sie48:
  ld a,(n_rends)
  ld c, #48
  sub c
  jr nz, sie64
  ld hl, #item1
  call entityman_create_item
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sie64:
  ld a,(n_rends)
  ld c, #64
  sub c
  jr nz, sie88
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo

sie88:
  ld a,(n_rends)
  ld c, #88
  sub c
  jr nz, sie104
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo
  
sie104:
  ld a,(n_rends)
  ld c, #104
  sub c
  jr nz, sie112
  ld hl, #obstaculo2
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item
  ld hl, #obstaculo4
  call entityman_create_obstaculo

sie112:
  ld a,(n_rends)
  ld c, #112
  sub c
  jr nz, sie120
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  
sie120:
  ld a,(n_rends)
  ld c, #120
  sub c
  jr nz, sie128
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #obstaculo5
  call entityman_create_obstaculo

sie128:
  ld a,(n_rends)
  ld c, #128
  sub c
  jr nz, sie136
  ;;ld hl, #submarino2
  ;;call entityman_create_obstaculo
  ld hl, #enemigo3
  ;;call entityman_create_enemigo
  ;;ld hl, #submarino4
  call entityman_create_obstaculo

sie136:
  ld a,(n_rends)
  ld c, #136
  sub c
  jr nz, sie144
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo

sie144:
  ld a,(n_rends)
  ld c, #144
  sub c
  jr nz, sie152
  ;;ld hl, #submarino2
  ;;call entityman_create_obstaculo
  ;;ld hl, #submarino4
  ;;call entityman_create_obstaculo

sie152:
  ld a,(n_rends)
  ld c, #152
  sub c
  jr nz, sie160
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #item3
  call entityman_create_item

sie160:
  ld a,(n_rends)
  ld c, #160
  sub c
  jr nz, sie168
  ;;ld hl, #submarino2
  ;;call entityman_create_obstaculo
  ;;ld hl, #submarino4
  ;;call entityman_create_obstaculo

sie168:
  ld a,(n_rends)
  ld c, #168
  sub c
  jr nz, sie176
  ld hl, #item1
  call entityman_create_item

sie176:
  ld a,(n_rends)
  ld c, #176
  sub c
  jr nz, sie184
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

sie184:
  ld a,(n_rends)
  ld c, #184
  sub c
  jr nz, sie192
  ld hl, #item4
  call entityman_create_item

sie192:
  ld a,(n_rends)
  ld c, #192
  sub c
  jr nz, sie208
  ld hl, #obstaculo1
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

sie208:
  ld a,(n_rends)
  ld c, #208
  sub c
  jr nz, sie240
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #obstaculo3
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

sie240:
  ld a,(n_rends)
  ld c, #240
  sub c
  jr nz, sie248
  ld hl, #enemigo1
  call entityman_create_enemigo
  ld hl, #item4
  call entityman_create_item
  ld hl, #enemigo5
  call entityman_create_enemigo

sie248:
  ld a,(n_rends)
  ld c, #248
  sub c
  jr nz, acaba7
  ld hl, #submarino1
  call entityman_create_obstaculo
  ld hl, #submarino2
  call entityman_create_obstaculo
  ld hl, #submarino3
  call entityman_create_obstaculo
  ld hl, #submarino4
  call entityman_create_obstaculo
  ld hl, #submarino5
  call entityman_create_obstaculo

acaba7:
  ld a, #18
  halt       
  dec a
  jr nz, .-2

ld a, (n_rends)  
inc a
ld (n_rends), a
jp level7_loop

win_level0:
  call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    ;; Estos 2 datos se los paso al render
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #102
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level1

win_level1:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    ;; Estos 2 datos se los paso al render
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level02

win_level02:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    ;; Estos 2 datos se los paso al render
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level03

win_level03:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level04

win_level04:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level2

win_level2:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    ;; Estos 2 datos se los paso al render
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6

call level1_end_borrar
jp level3

win_level3:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level6

win_level6:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level4

win_level4:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level5

win_level5:call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level06

win_level06:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level7

win_level7:
call cpct_akp_stop_asm
;; Esto estaría mejor en una funcion music init
  ld de, #_song_level
  call cpct_akp_musicInit_asm
call entityman_getEntityArray_IX
call entityman_getNumEntities_A    
call renderys_borrarTodasEntidades
call borrar_hud
ld a, (level)
inc a
ld (level), a
ld a, #00
ld (n_rends), a
call level1_end
ld a, #78
   halt  
   halt     
   halt 
   halt
   halt
   dec a
   jr nz, .-6
call level1_end_borrar
jp level0

loop_gameover:
  ld a, #00 
  ld (n_rends), a

  call entityman_getEntityArray_IX
  call entityman_getNumEntities_A 
  call rendersys_gameover

  call cpct_akp_stop_asm
  ld de, #_song_muerte
  call cpct_akp_musicInit_asm
  ld a, #78
  halt  
  halt     
  halt 
  halt
  halt
  dec a
  jr nz, .-6

  call entityman_getEntityArray_IX
  call entityman_getNumEntities_A 
  call renderys_borrarTodasEntidades
  call borrar_hud
  call cpct_akp_stop_asm
  ld de, #_song_menu2
  call cpct_akp_musicInit_asm
  
  loop_gameover2:
    ;;call cpct_akp_stop_asm
    call over_init
    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr nz, niveles
    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr z, loop_gameover2
    call fondo_juego_borrar
    call borrar_over
    ld a, #01
    ld (level), a
  jp loop_menu

  
niveles:
  call fondo_juego_borrar 
  call borrar_over
  ld a, (level)
  ld c, #01
  sub c
  jp z, level0

  ld a, (level)
  ld c, #02
  sub c
  jp z, level1

  ld a, (level)
  ld c, #03
  sub c
  jp z, level02

  ld a, (level)
  ld c, #04
  sub c
  jp z, level03

  ld a, (level)
  ld c, #05
  sub c
  jp z, level04

  ld a, (level)
  ld c, #06
  sub c
  jp z, level2

  ld a, (level)
  ld c, #07
  sub c
  jp z, level3

  ld a, (level)
  ld c, #08
  sub c
  jp z, level6

  ld a, (level)
  ld c, #09
  sub c
  jp z, level4

  ld a, (level)
  ld c, #10
  sub c
  jp z, level5

  ld a, (level)
  ld c, #11
  sub c
  jp z, level06

  ld a, (level)
  ld c, #12
  sub c
  jp z, level7

loop:

  ;; Actualizamos fisicas
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call sys_input_update
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call sys_physics_update
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call sys_physics_update_obstaculo
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call sys_physics_update_enemigo
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call dispara_enemigo
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call sys_physics_update_balaEnemigo  
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call sys_physics_update_bala
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A    
   call sys_physics_update_item

  ;; Comprobamos colisiones
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call checkColision_nave
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call checkColision_item
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call checkColision_bala

  ;; Renderizamos
   ld a, (wait4rend)
   dec a
   jr nz, noRender
 
   ld a, #2
   ld (wait4rend), a
   ;;call entityman_getEntityArray_IX
   ;;call entityman_getNumEntities_A 
   call rendersys_update
   ld a , (animate)
   inc a
   ld (animate), a

  noRender:

ret

creditos:
  call creditos_init
  call cpct_scanKeyboard_f_asm
  ld hl, #Key_Esc
  call cpct_isKeyPressed_asm
  jr z, volver_menu
  call creditos_borrar
  call loop_menu

  volver_menu:
    jp creditos
