;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Bubble Shark by Tradware
;;  Copyright (C) 2020
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
;;
;; RENDER SYSTEM
;;

.include "cpctelera.h.s" 
.include "cpct_functions.h.s"
.include "entity_manager.h.s"
.include "render_system.h.s"
.include "input_system.h.s"
.include "physics_system.h.s"

.globl _spr_player
.globl _spr_player2
.globl _spr_player3
.globl _spr_mina
.globl _pal_player
.globl _spr_bala
.globl _spr_bala2
.globl _spr_pez
.globl _spr_pez2
.globl _spr_pez_puntos
.globl _spr_buzo
.globl _spr_buzo2
.globl _spr_buzogirado
.globl _spr_buzogirado2
.globl _spr_balaEnemigo
.globl _spr_balaEnemigogirado
.globl _spr_sub
.globl _spr_sub2
.globl _spr_nube
.globl _spr_barco
.globl _spr_alga
.globl _spr_algaGrande
.globl _spr_algaGrande2
.globl _spr_coral
.globl _spr_coral2
.globl _spr_almeja
.globl _spr_reloj

;; ---------------------
;; MENU
;; ---------------------

x: .db #20
y: .db #12

;; Menu ----
str_menu: .asciz "    BUBBLE SHARK"
str_menu2: .asciz "      1. PLAY"
str_menu3: .asciz "     2. CREDITS"

;; Creditos ----
_creditos: .asciz "       CREDITS"
_jc: .asciz "JUAN CARLOS SORIANO"
_loli: .asciz "  DOLORES SANTIAGO"
_juanmi: .asciz " JUAN MIGUEL ALONSO"

str_over: .asciz "GAME OVER"
str_over2: .asciz "PRESS SPACE TO"
str_over22: .asciz "RESTART"
str_over3: .asciz "PRESS ESC TO GO "
str_over33: .asciz "MAIN MENU"
str_level1: .asciz "LEVEL 1"
str_level2: .asciz "LEVEL 2"
str_level3: .asciz "LEVEL 3"
str_level4: .asciz "LEVEL 4"
str_level5: .asciz "LEVEL 5"
str_level6: .asciz "LEVEL 6"
str_level7: .asciz "LEVEL 7"
str_level8: .asciz "LEVEL 8"
str_level9: .asciz "LEVEL 9"
str_level10: .asciz "LEVEL 10"
str_level11: .asciz "LEVEL 11"
str_level12: .asciz "LEVEL 12"
str_take: .asciz "TAKE"
str_start: .asciz "START"
str_level1end: .asciz "GOOD JOB!"
str_puntosNumero0: .asciz "X0"
str_puntosNumero1: .asciz "X1"
str_puntosNumero2: .asciz "X2"
str_puntosNumero3: .asciz "X3"
str_puntosNumero4: .asciz "X4"
str_puntosNumero5: .asciz "X5"
str_puntosNumero6: .asciz "X6"
str_puntosNumero7: .asciz "X7"
str_puntosNumero8: .asciz "X8"
str_puntosNumero9: .asciz "X9"
str_puntosNumero10: .asciz "X10"
str_puntosNumero11: .asciz "X11"
str_puntosNumero12: .asciz "X12"
animate: .db 00


;; Pie de juego, empresa
_str_empresa: .asciz "         BY TRADWARE"

menu_init::
    ld hl, #0x0D ;; 0x030F fondo lila 030D fondo lila texto amarillo 060D fondo azul claro
    call cpct_setDrawCharM0_asm
    ld iy, #str_menu
    ld hl, #0xE8A0
    call _myDrawStringM0

    ld hl, #0x01
    call cpct_setDrawCharM0_asm
    ld iy, #str_menu2
    ld hl, #0xEAD0
    call _myDrawStringM0

    ld hl, #0x01
    call cpct_setDrawCharM0_asm
    ld iy, #str_menu3
    ld hl, #0xEBC0
    call _myDrawStringM0

    ld hl, #0x03 ;; 0F blanco ;; 0x03 lila
    call cpct_setDrawCharM0_asm
    ld iy, #_str_empresa
    ld hl, #0xEF30
    call _myDrawStringM0

    ;;---- Dibujar burbujas de fondo
     ;; Dibujamos
        ld de, #0xC000
        ld c, #40             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #50             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia8

        ld hl, #_spr_bala2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten8
        ld a, #00
        ld (animate),a
        jp manten8

        cambia8:
        ld hl, #_spr_bala       ;; carga en hl la primera posicion de memoria del sprite
    
        manten8:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #65             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #70             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia9

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten9
        ld a, #00
        ld (animate),a
        jp manten9

        cambia9:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten9:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #75             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #110             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia10

        ld hl, #_spr_bala2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten10
        ld a, #00
        ld (animate),a
        jp manten10

        cambia10:
        ld hl, #_spr_bala       ;; carga en hl la primera posicion de memoria del sprite
    
        manten10:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #60             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #130             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia11

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten11
        ld a, #00
        ld (animate),a
        jp manten11

        cambia11:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten11:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #20             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #40             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia12

        ld hl, #_spr_bala2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten12
        ld a, #00
        ld (animate),a
        jp manten12

        cambia12:
        ld hl, #_spr_bala       ;; carga en hl la primera posicion de memoria del sprite
    
        manten12:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #20             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #140             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia13

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten13
        ld a, #00
        ld (animate),a
        jp manten13

        cambia13:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten13:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #50             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #160             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia14

        ld hl, #_spr_bala2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten14
        ld a, #00
        ld (animate),a
        jp manten14

        cambia14:
        ld hl, #_spr_bala       ;; carga en hl la primera posicion de memoria del sprite
    
        manten14:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #5             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #85             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia15

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten15
        ld a, #00
        ld (animate),a
        jp manten15

        cambia15:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten15:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #35            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #130             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia16

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten16
        ld a, #00
        ld (animate),a
        jp manten16

        cambia16:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten16:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #70             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #170             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia17

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten17
        ld a, #00
        ld (animate),a
        jp manten17

        cambia17:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten17:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #2             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #13            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia18

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten18
        ld a, #00
        ld (animate),a
        jp manten18

        cambia18:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten18:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #70             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #10             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia19

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten19
        ld a, #00
        ld (animate),a
        jp manten19

        cambia19:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten19:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm

        ld de, #0xC000
        ld c, #7             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #170           ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia20

        ld hl, #_spr_bala
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten20
        ld a, #00
        ld (animate),a
        jp manten20

        cambia20:
        ld hl, #_spr_bala2       ;; carga en hl la primera posicion de memoria del sprite
    
        manten20:
        ld c, #4              
        ld b, #8
        call cpct_drawSprite_asm
ret

menu_run::
    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr z, menu_run
ret

level0_init::
    ;; Nombre del juego
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level1
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero3
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;ld iy, #str_puntosNumero6
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level1_init::
    ;; Nombre del juego
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level2
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero6
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;ld iy, #str_puntosNumero6
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

borrar_level:
    ;; Nombre del juego
    ld hl, #0x00 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level10
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x0000 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ex de, hl
    ld a, #0x0000
    ld c, #8           
    ld b, #8
    call cpct_drawSolidBox_asm
    
    
    ld hl, #0x0000 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero12
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ;; Press Q to START
    ld hl, #0x00;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level02_init::
    ;; Nombre del juego
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level3
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero6
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;ld iy, #str_puntosNumero6
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level2_init::
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level6
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm


    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero9
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level03_init::
    ;; Nombre del juego
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level4
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero8
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;ld iy, #str_puntosNumero6
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level06_init::
    ;; Nombre del juego
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level11
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero8
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;ld iy, #str_puntosNumero6
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level3_init::
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level7
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm


    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero8
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level04_init::
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level5
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm


    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero6
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level4_init::
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level9
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm


    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero7
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level5_init::
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level10
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm


    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero10
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level6_init::
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level8
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm


    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero7
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level7_init::
    ld hl, #0x03 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level12
    X = 58
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 55
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_take
    X = 40
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm


    X = 58
    Y = 90
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ld hl, #0x000f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero7
    X = 63
    Y = 90
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 90
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm



    ;; Press Q to START
    ld hl, #0x0f;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_start
    X = -1
    Y = 150
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 20
    ;;Y = 120
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level1_end::
    ld hl, #0x0b ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level1end
    X = 55
    Y = 96
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 40
    ;;Y = 96
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

level1_end_borrar::
    ld hl, #0x00 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_level1end
    X = 55
    Y = 96
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 40
    ;;Y = 96
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm
ret

over_init::
    ld hl, #4 ;; COLOR game over
    call cpct_setDrawCharM0_asm
    ld iy, #str_over
    X = 55
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 60
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ;; Press Q to START
    ld hl, #0x0f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_over2
    X = 27
    Y = 95
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 0
    ;;Y = 80
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ;; Press Q to START
    ld hl, #0x0f ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_over22
    X = 75
    Y = 105
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
ret

over_run::
    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jp z, menu_run
ret

borrar_menu::
    ld hl, #60 ;; 0x030F fondo lila 030D fondo lila texto amarillo 060D fondo azul claro
    call cpct_setDrawCharM0_asm
    ld iy, #str_menu
    ld hl, #0xE8A0
    call _myDrawStringM0

    ld hl, #0x00
    call cpct_setDrawCharM0_asm
    ld iy, #str_menu2
    ld hl, #0xEAD0
    call _myDrawStringM0

    ld hl, #0x00
    call cpct_setDrawCharM0_asm
    ld iy, #str_menu3
    ld hl, #0xEBC0
    call _myDrawStringM0

    ld hl, #0x00 ;; 0F blanco ;; 0x03 lila
    call cpct_setDrawCharM0_asm
    ld iy, #_str_empresa
    ld hl, #0xEF30
    call _myDrawStringM0

      ld de, #0xC000
        ld c, #40             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #50             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #65             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #70             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #75             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #110             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #60             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #130             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #20             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #40             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #20             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #140             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #50             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #160             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #5             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #85             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #35            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #130             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #70             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #170             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #2             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #13            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #70             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #10             ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

        ld de, #0xC000
        ld c, #7             ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #170           ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, #4               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, #8 
        call cpct_drawSolidBox_asm

ret

rendersys_gameover::
    ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld hl, #_spr_player3  
   ;; carga en hl la primera posicion de memoria del sprite 
        ld c, e_w(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_h(ix)                 ;; alto en bytes
        call cpct_drawSprite_asm
ret

borrar_over::
  ld hl, #0 ;; COLOR game over
    call cpct_setDrawCharM0_asm
    ld iy, #str_over
    X = 55
    Y = 60
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 50
    ;;Y = 60
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ;; Press Q to START
    ld hl, #0x00 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_over2
    X = 27
    Y = 95
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 0
    ;;Y = 80
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

    ;; Press Q to START
    ld hl, #0x00 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_over22
    X = 75
    Y = 105
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0

ret

;; ---------------------
;; HUD
;; ---------------------

borrar_hud:
    X = 65
    Y = 0
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld a, #60
    ld c, #16          
    ld b, #8
    call cpct_drawSolidBox_asm

    ld hl, #0x0606 ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero12
    jp pint0
    X = 70
    Y = 0
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0
    ;;X = 36
    ;;Y = 0
    ;;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;;call cpct_drawStringM0_asm

ret

hud_init::
    ;; Texto puntos
  
    X = 65
    Y = 0
    ld de, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ld hl, #_spr_pez_puntos
    ld c, #4           
    ld b, #8
    call cpct_drawSprite_asm
    
    
    ;; Puntuacion numero 0
    ld c, #00
    call entityman_getPuntos_A
    sub c
    jr nz, punt1
    ld hl, #0x060F ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero0
    jp pint0

    punt1:
     ;; Puntuacion numero 1
    ld c, #01
    call entityman_getPuntos_A
    sub c
    jr nz, punt2
    ld hl, #0x060F  ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero1
    jp pint0

    punt2:
     ;; Puntuacion numero 1
    ld c, #02
    call entityman_getPuntos_A
    sub c
    jr nz, punt3
    ld hl, #0x060F  ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero2
    jp pint0

    punt3:
     ;; Puntuacion numero 1
    ld c, #03
    call entityman_getPuntos_A
    sub c
    jr nz, punt4
    ld hl, #0x060F ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero3
    jp pint0

    punt4:
     ;; Puntuacion numero 1
    ld c, #04
    call entityman_getPuntos_A
    sub c
    jr nz, punt5
    ld hl, #0x060F ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero4
    jp pint0

    punt5:
     ;; Puntuacion numero 1
    ld c, #05
    call entityman_getPuntos_A
    sub c
    jr nz, punt6
    ld hl, #0x060F  ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero5
    jp pint0

    punt6:
     ;; Puntuacion numero 1
    ld c, #06
    call entityman_getPuntos_A
    sub c
    jr nz, punt7
    ld hl, #0x060F ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero6
    jp pint0

    punt7:
     ;; Puntuacion numero 1
    ld c, #07
    call entityman_getPuntos_A
    sub c
    jr nz, punt8
    ld hl, #0x060F ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero7
    jp pint0

    punt8:
     ;; Puntuacion numero 1
    ld c, #08
    call entityman_getPuntos_A
    sub c
    jr nz, punt9
    ld hl, #0x060F  ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero8
    jp pint0

    punt9:
     ;; Puntuacion numero 1
    ld c, #09
    call entityman_getPuntos_A
    sub c
    jr nz, punt10
    ld hl, #0x060F ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero9
    jp pint0

    punt10:
     ;; Puntuacion numero 1
    ld c, #10
    call entityman_getPuntos_A
    sub c
    jr nz, punt11
    ld hl, #0x060F  ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero10
    jp pint0

    punt11:
     ;; Puntuacion numero 1
    ld c, #11
    call entityman_getPuntos_A
    sub c
    jr nz, punt12
    ld hl, #0x060F  ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero11
    jp pint0

    punt12:
    ld hl, #0x060F  ;; COLOR
    call cpct_setDrawCharM0_asm
    ld iy, #str_puntosNumero12
    jp pint0

    pint0:
    X = 70
    Y = 0
    ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call _myDrawStringM0

ret

;; CREDITOS
creditos_init::
    ld hl, #0x0D 
    call cpct_setDrawCharM0_asm

    ld iy, #_creditos
    ld hl, #0xE8A0
    call _myDrawStringM0

    ld hl, #0x0F 
    call cpct_setDrawCharM0_asm

    ld iy, #_jc
    ld hl, #0xE9E4
    call _myDrawStringM0

    ld hl, #0x0F 
    call cpct_setDrawCharM0_asm

    ld iy, #_loli
    ld hl, #0xEB20
    call _myDrawStringM0

    ld hl, #0x0F 
    call cpct_setDrawCharM0_asm

    ld iy, #_juanmi
    ld hl, #0xEC60
    call _myDrawStringM0
ret

creditos_borrar::
    ld hl, #60
    call cpct_setDrawCharM0_asm
    ld iy, #_creditos
    ld hl, #0xE8A0
    call _myDrawStringM0

    ld hl, #0x00
    call cpct_setDrawCharM0_asm
    ld iy, #_jc
    ld hl, #0xE9E4
    call _myDrawStringM0

    ld hl, #0x00 
    call cpct_setDrawCharM0_asm
    ld iy, #_loli
    ld hl, #0xEB20
    call _myDrawStringM0

    ld hl, #0x00 
    call cpct_setDrawCharM0_asm
    ld iy, #_juanmi
    ld hl, #0xEC60
    call _myDrawStringM0
ret

;; ---------------------
;; ENTIDADES
;; ---------------------

rendersys_init::
    ld c, #0
    call cpct_setVideoMode_asm
    
    ld hl, #_pal_player
    ld de, #16

    call cpct_setPalette_asm
    cpctm_setBorder_asm HW_BLACK
    ;; un carril son 22 h   de 44 a 66

    ld de, #0xC000
    ld a, #00
    ld c, #40
    ld b, #200
    call cpct_drawSolidBox_asm

    ld de, #0xC028
    ld a, #00
    ld c, #40
    ld b, #200
    call cpct_drawSolidBox_asm

    ret

fondo_juego::
    ;; cielo 
    ld de, #0xC000
    ld a, #60
    ld c, #40
    ld b, #44
    call cpct_drawSolidBox_asm

    ld de, #0xC028
    ld a, #60
    ld c, #40
    ld b, #44
    call cpct_drawSolidBox_asm

    ;; imprime las nubes
    ld de, #0xC010
    ld hl, #_spr_nube
    ld c, #12              
    ld b, #16
    call cpct_drawSprite_asm

    ld de, #0xC032
    ld hl, #_spr_nube
    ld c, #12              
    ld b, #16
    call cpct_drawSprite_asm

    ;; imprime barco
    ld de, #0xE115
    ld hl, #_spr_barco
    ld c, #12              
    ld b, #16
    call cpct_drawSprite_asm

    ;; corales
    ld de, #0xE5F0
    ld a, #00
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm

    ld de, #0xE618
    ld a, #00
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm

    ;; fondo marino
    ld de, #0xD6E0
    ld a, #240
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm

    ld de, #0xD708
    ld a, #240
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm

    ;; sprites fondo

    ld de, #0xF5F9
    ld hl, #_spr_algaGrande
    ld c, #4
    ld b, #20
    call cpct_drawSprite_asm

    ld de, #0xF605
    ld hl, #_spr_algaGrande2
    ld c, #4
    ld b, #20
    call cpct_drawSprite_asm

    ld de, #0xF635
    ld hl, #_spr_algaGrande2
    ld c, #4
    ld b, #20
    call cpct_drawSprite_asm

    ld de, #0xF625
    ld hl, #_spr_algaGrande2
    ld c, #4
    ld b, #20
    call cpct_drawSprite_asm

    ld de, #0xF609
    ld hl, #_spr_algaGrande
    ld c, #4
    ld b, #20
    call cpct_drawSprite_asm

    ld de, #0xF62F
    ld hl, #_spr_algaGrande
    ld c, #4
    ld b, #20
    call cpct_drawSprite_asm

    ld de, #0xC69F
    ld hl, #_spr_coral
    ld c, #4              
    ld b, #10
    call cpct_drawSprite_asm

    ld de, #0xC6D1
    ld hl, #_spr_reloj
    ld c, #4              
    ld b, #10
    call cpct_drawSprite_asm

    ld de, #0xD690
    ld hl, #_spr_alga
    ld c, #4              
    ld b, #8
    call cpct_drawSprite_asm

    ld de, #0xD6B9
    ld hl, #_spr_alga
    ld c, #4              
    ld b, #8
    call cpct_drawSprite_asm

    ld de, #0xD694
    ld hl, #_spr_coral2
    ld c, #4              
    ld b, #8
    call cpct_drawSprite_asm

    ld de, #0xD6B0
    ld hl, #_spr_coral2
    ld c, #4              
    ld b, #8
    call cpct_drawSprite_asm

    ld de, #0xD6BF
    ld hl, #_spr_coral2
    ld c, #4              
    ld b, #8
    call cpct_drawSprite_asm

    ld de, #0xC735
    ld hl, #_spr_almeja
    ld c, #6              
    ld b, #12
    call cpct_drawSprite_asm

    ld de, #0xC745
    ld hl, #_spr_almeja
    ld c, #6              
    ld b, #12
    call cpct_drawSprite_asm

    ld de, #0xC770
    ld hl, #_spr_almeja
    ld c, #6              
    ld b, #12
    call cpct_drawSprite_asm

    ld de, #0xD779
    ld hl, #_spr_almeja
    ld c, #6              
    ld b, #12
    call cpct_drawSprite_asm

    ld de, #0xE760
    ld hl, #_spr_almeja
    ld c, #6              
    ld b, #12
    call cpct_drawSprite_asm
    
    ret

fondo_juego_borrar::
    ;; cielo 
    ld de, #0xC000
    ld a, #00
    ld c, #40
    ld b, #44
    call cpct_drawSolidBox_asm

    ld de, #0xC028
    ld a, #00
    ld c, #40
    ld b, #44
    call cpct_drawSolidBox_asm

    ;; imprime las nubes
    ld de, #0xC010
    ld a, #00
    ld c, #12
    ld b, #16
    call cpct_drawSolidBox_asm

    ld de, #0xC032
    ld a, #00
    ld c, #12              
    ld b, #16
    call cpct_drawSolidBox_asm

    ;; imprime barco
    ld de, #0xE115
    ld a, #00
    ld c, #12              
    ld b, #16
    call cpct_drawSolidBox_asm

    ;; corales
    ld de, #0xE5F0
    ld a, #00
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm

    ld de, #0xE618
    ld a, #00
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm

    ;; fondo marino
    ld de, #0xD6E0
    ld a, #00
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm

    ld de, #0xD708
    ld a, #00
    ld c, #40
    ld b, #22
    call cpct_drawSolidBox_asm
    
    ret


rendersys_update_nave::

        ;; Borramos
        ld de, #0xC000
        ld c, e_antx(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00                   ;; el color esta en la posicion 3
        ld c, e_w(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_h(ix) 
        call cpct_drawSolidBox_asm

        ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ;;ld a, e_color (ix)          ;; el color esta en la posicion 3
        ;;ld c, e_h(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ;;ld b, e_w(ix) 
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia

        ld hl, #_spr_player2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten
        ld a, #00
        ld (animate),a
        jp manten

        cambia:
        ld hl, #_spr_player        ;; carga en hl la primera posicion de memoria del sprite
    
        manten:
        ld c, e_w(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_h(ix)                 ;; alto en bytes
        call cpct_drawSprite_asm

        jp saltaEntidad

ret

rendersys_update_enemigo::

        ;; Borramos
        ld de, #0xC000
        ld c, e_antx(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld (de), a
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSolidBox_asm

        ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de

        call entityman_getEntityArray_HL 
         ;; IZQUIERDA---------------------
        ;; obstaculo_x + obstaculo_W - nave_x <= 0
        ld a , e_x(ix)  ;; guardamos la posicion x del obstaculo
        ld c,a ;; lo metemos en c
        ld a, e_w(ix) ;;guardamos la mitad de la anchura del obstaculo ANTES 18
        add a,c
        inc hl ;; incrementamos 1 hl porque apuntaba al primer byte (flag)
        sub (hl)
        jr z , saltaizq2 ;;si es 0 no colisiona
        jp m , saltaizq2;; si es menor que 0 no colisiona

        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia21

        ld hl, #_spr_buzo2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten21
        ld a, #00
        ld (animate),a
        jp manten21

        cambia21:
        ld hl, #_spr_buzo
        jp manten21

        saltaizq2:
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia22

        ld hl, #_spr_buzogirado2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten21
        ld a, #00
        ld (animate),a
        jp manten21

        cambia22:
        ld hl, #_spr_buzogirado

        manten21:
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSprite_asm

        jp saltaEntidad

ret

rendersys_update_bala::

        ;; Borramos
        ld de, #0xC000
        ld c, e_antx(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, e_w(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_h(ix) 
        call cpct_drawSolidBox_asm

        ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia2

        ld hl, #_spr_bala2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten2
        ld a, #00
        ld (animate),a
        jp manten2

        cambia2:
        ld hl, #_spr_bala       ;; carga en hl la primera posicion de memoria del sprite
    
        manten2:
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSprite_asm

        jp saltaEntidad

ret

rendersys_update_balaEnemigo::

        ;; Borramos
        ld de, #0xC000
        ld c, e_antx(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld c, e_w(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_h(ix) 
        call cpct_drawSolidBox_asm

        ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)     
        ld b, e_y(ix)  
        call cpct_getScreenPtr_asm 
        ex de, hl              
        ;;ld a, e_color (ix)
        ;;ld (de), a
        ld hl, #_spr_balaEnemigogirado
        ld c, #0x06
        ld a, e_flag(ix)
        sub c
        jr z, salto

        ld hl, #_spr_balaEnemigo
        salto:
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSprite_asm

        jp saltaEntidad

    ret

rendersys_update_obstaculo::

        ;; Borramos
        ld de, #0xC000
        ld c, e_antx(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld (de), a
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSolidBox_asm

        ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld hl, #_spr_mina
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSprite_asm

        jp saltaEntidad

ret
rendersys_update_submarino::

        ;; Borramos
        ld de, #0xC000
        ld c, e_antx(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld (de), a
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSolidBox_asm

        ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de

        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia3

        ld hl, #_spr_sub2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten3
        ld a, #00
        ld (animate),a
        jp manten3

        cambia3:
        ld hl, #_spr_sub       ;; carga en hl la primera posicion de memoria del sprite
    
        manten3:
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSprite_asm

        jp saltaEntidad

ret
rendersys_update_item::

         ;; Borramos
        ld de, #0xC000
        ld c, e_antx(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld (de), a
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSolidBox_asm

        ;; Dibujamos
        ld de, #0xC000
        ld c, e_x(ix)               ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)               ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld c, #05
        ld a, (animate)
        cp c
        jr c, cambia4

        ld hl, #_spr_pez2
        ld c, #10
        ld a, (animate)
        cp c
        jr c, manten4
        ld a, #00
        ld (animate),a
        jp manten4

        cambia4:
        ld hl, #_spr_pez     ;; carga en hl la primera posicion de memoria del sprite
    
        manten4:
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSprite_asm

        jp saltaEntidad

ret
rendersys_update_loQueToca::

    _loopTodasEntidades:

    push af

        ld c, #0x01
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_nave

        ld c, #0x02
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_obstaculo

        ld c, #0x03
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_bala

        ld c, #0x04
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_item

        ld c, #0x05
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_enemigo

        ld c, #0x06
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_balaEnemigo

        ld c, #0x07
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_balaEnemigo

        ld c, #0x08
            ld a, e_flag(ix)
            sub c
            jp z, rendersys_update_submarino

    saltaEntidad::
        pop af
        dec a
        ret z
        ld bc, #sizeof_e
        add ix, bc

    jr _loopTodasEntidades

    ret



rendersys_update::
    
    call hud_init
    call entityman_getEntityArray_IX 
    call entityman_getNumEntities_A
    call rendersys_update_loQueToca

ret

rendersys_borraBalaInvalida::
        ld de, #0xC000
        ld c, e_antx(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_anty(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld (de), a
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSolidBox_asm

ret

renderys_borrarTodasEntidades::
_renloop5:
        push af
        ld de, #0xC000
        ld c, e_x(ix)            ;; carga en c lo que hay en ix mas 1. POSICIOM
        ld b, e_y(ix)            ;; carga en c lo que hay en ix mas 2. POSICION
        call cpct_getScreenPtr_asm  ;; Calculo el puntero a pantalla, lo tengo en hl
        ex de, hl                   ;; intercambio lo que hay en hl a de
        ld a, #00       
        ld (de), a
        ld c, e_w(ix)              
        ld b, e_h(ix)
        call cpct_drawSolidBox_asm

        pop af
        dec a
        ret z
        ld bc, #sizeof_e
        add ix, bc

    jr _renloop5